=== debian/changelog ===
dcmtk (3.6.5-1) unstable; urgency=medium

  * debian/control: switch to comat level 10
  * d/rules: don't install libcharls.so Closes: #971433
    Closes: #971412
  * d/control: cme fix dpkg
  * d/compat: remove obsolete file

 -- Gert Wollny <gewo@debian.org>  Tue, 10 Nov 2020 15:08:59 +0100

dcmtk (3.6.5-1~exp1) experimental; urgency=medium

  [ Andreas Tille ]
  * Remove myself as Uploader

  [ Gert Wollny ]
  * New upstream version 3.6.5
  * d/p: Update patches and remove 08 (applied upstream)
  * Update SO version to 15
  * d/copyright: all-over year and new files

 -- Gert Wollny <gewo@debian.org>  Fri, 20 Dec 2019 21:31:03 +0100
